!= Module ECCM
!
! Authors::   SUGIYAMA Koichiro, ODAKA Masatsugu
! Version::   $Id: eccm.f90,v 1.29 2011-02-28 12:00:24 sugiyama Exp $
! Tag Name::  $Name: arare4-20110302 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǮŪ˾徺뵤βٸΨ׻, ſ尵ʿդ鰵Ϥ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * Ǯ, ʿʬ̤
!  * 顼٤­ʤΤ, 󥲥å. 
!
!== Future Plans
!

module ECCM

  !⥸塼ɤ߹

  use gtool_history                   !ˤnetCDFǡɤ߹ि
                                      !⥸塼(for ECC_N1994)
  use dc_message, only: MessageNotify

  use gridset,  only: DimZMin,       &!  Z β
    &                 DimZMax,       &!  Z ξ 
    &                 RegZMin,       &!
    &                 SpcNum,        &!
    &                 s_Z,           &!
    &                 DelZ            !
  use basicset,only:  MolWtDry,      &!
    &                 MolWtWet,      &!
    &                 CpDryMol,      &!
    &                 SpcWetID,      &!
    &                 TempSfc,       &!
    &                 PressSfc,      &!
    &                 Grav,          &!
    &                 GasRDry,       &!ɲ(for ECC_N1994)
    &                 CpDry           !ɲ(for ECC_N1994)
  use chemcalc, only: SvapPress,        &!
    &                 LatentHeatPerMol, &!
    &                 ReactHeatNH4SHPerMol
  use moistset, only: CondNum,          &!ŷο
    &                 IdxCG,            &!ŷ()ź
    &                 IdxCC,            &!ŷ()ź
    &                 GasNum,           &!Το
    &                 IdxNH3,           &!NH3()ź
    &                 IdxH2S             !H2S()ź
  use ChemData, only: GasRUniv        
  use MoistFunc,only: DelMolFrNH4SH 
  use StoreStab,only: StoreStabTemp, StoreStabMolWt

  !ۤηػ
  implicit none

  !°λ
  private

  !ؿθ
  public ECCM_init           !NAMELISTѤ뤿ν롼 
  public ECCM_MolFr
  public ECCM_Stab
  public ECCM_Dry
  public ECCM_Wet
  public ECCM_Wet2
  public HUM                 !ECCM_N1994Ѥм٤δܾ
  public ECCM_N1994            !Yamasaki(1983)β٤м٤Ǵܾ
  public HUM_Takemi2007      !Takemi(2007)м٤δܾ()
  public HUM_Takemi2007_TDRY !Takemi(2007)м٤δܾ()
  public HUM_Takemi2007_MDRY !Takemi(2007)м٤δܾ()
  public ECCM_Takemi2007     !Takemi(2007)β٤ȼ٤Ǵܾ
  public HUM_Takemi2007ALL   !Takemi(2007)м٤δܾ(for ECCM_MolFr)

  real(8)  :: DryHeight = 0.0d0

  save DryHeight
  
contains

!!!-------------------------------------------------------------------!!!
  subroutine ECCM_init(cfgfile)
    !
    ! ECCM ⥸塼ν롼
    !

    !ۤηػ
    implicit none

    !
    !NAMELIST Ͷ
    !

  character(*), intent(in) :: cfgfile

    ! NAMELIST 
    NAMELIST /eccm/ DryHeight

    open (10, FILE=cfgfile)
    read(10, NML=eccm)
    close(10)

    !ǧ
    call MessageNotify( "M", "ECCM_init", "DryHeight = %f", d=(/DryHeight/) )

  end subroutine ECCM_init
!!!------------------------------------------------------------------------------!!!
!  subroutine ECCM_Dry( a_MolFrIni, Humidity, z_Temp, z_Press, z_MolWtMean, za_MolFr )
  subroutine ECCM_Dry( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
    !
    !== 
    !  * ǮٸΨ˱ä١ϤᡢФƻꤵ줿м٤Ȥʤ褦˶ŷʬΥ
    !  * Ǯϴ絤ΤΤɽ
    !    * ήΤˤǮϴʬΤΤɽƤ뤿
    !  * 絤ʿʬ̤ˤϼʬʬ̤
    !    * ήΤˤ, ʬʬ̤ϹθƤ뤿
    !
    
    !ۤηػ
    implicit none
    
    real(8), intent(in) :: a_MolFrIni(1:SpcNum)    !ǤΥ
    real(8), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
    real(8), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(8), intent(out):: z_Press(DimZMin:DimZMax)!
!    real(8), intent(out):: z_MolWtMean(DimZMin:DimZMax) 
    real(8)             :: z_MolWtMean(DimZMin:DimZMax) 
                                                   !ʿʬ
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum) 
                                                   !ʬΨ
    real(8)             :: MolWtMeanDry            !絤ʬ̤κѿ
    real(8)             :: MolWtMeanWet            !ᵤʬ̤κѿ
    real(8)             :: SatPress                !˰¾
    real(8)             :: VapPress                !
    real(8)             :: DelMolFr
    integer             :: k, s

    !-------------------------------------------------------------
    ! ν
    !-------------------------------------------------------------
    !ɽ̤ʬ̤
    za_MolFr(RegZMin+1, 1:SpcNum)   = a_MolFrIni(1:SpcNum) 

    !ɽ̤Ǥʿʬ̤
    MolWtMeanDry = MolWtDry * (1.0d0 - sum(a_MolFrIni))
    MolWtMeanWet = dot_product(MolWtWet, a_MolFrIni) 
    z_MolWtMean(RegZMin+1) = MolWtMeanDry + MolWtMeanWet
  
    !ɽ̤Ǥβ(RegZMin+1 ,  DelZ / 2 )
    z_Temp          = 1.0d-60
    z_Temp(RegZMin+1) = TempSfc - Grav * MolWtDry &
      &                 / CpDryMol * ( DelZ * 5.0d-1 )
    
    !ɽ̤Ǥΰ(RegZMin+1 ,  DelZ / 2 )
    z_Press           = 1.0d-60
    z_Press(RegZMin+1)  = &
      & PressSfc *((TempSfc / z_Temp(RegZMin+1)) ** (- CpDryMol /  GasRUniv))
    
    !-----------------------------------------------------------
    ! (1) Ǯ˱ä٤
    ! (2) ſ尵ʿդ鰵Ϥ
    ! (3) (1),(2) βٰϤФ, Ȥм٤Ȥʤ
    !-----------------------------------------------------------    
    DtDz: do k = RegZMin+1, DimZMax-1

      !(1)Ǯ˱ä k+1 Ǥβ٤׻
      z_Temp(k+1) = z_Temp(k) - Grav * MolWtDry / CpDryMol * DelZ
      
      !ǰ
      if (z_Temp(k+1) <= 0.0d0 ) z_Temp(k+1) = z_Temp(k) 
      
      !(2)Ϥſ尵ʿդ׻
      z_Press(k+1) =                                                  &
        &  z_Press(k) * ((z_Temp(k) / z_Temp(k+1)) ** (- CpDryMol / GasRUniv)) 

      !(3)η׻
      !  ޤϥѲʤΤȤƥͿ
      !  ˰¾ʿȤʿվŬѤƤ
      za_MolFr(k+1,:) = za_MolFr(k,:)
      
      do s = 1, CondNum      
        !˰¾
        SatPress = SvapPress( SpcWetID(IdxCC(s)), z_Temp(k+1) )        
        
        !ΥʬΨѤƸߤξ׻
        VapPress = za_MolFr(k,IdxCG(s)) * z_Press(k+1)
        
        !˰¾ȰϤ鸽ߤΥ׻
        if ( VapPress > SatPress ) then         
          za_MolFr(k+1,IdxCG(s)) = max(SatPress * Humidity / z_Press(k+1), 1.0d-16)

        end if
!        write(*,*) k, s, z_Temp(k), za_MolFr(k,IdxCG(s)), VapPress, SatPress
      end do
      
      !NH4SH ʿվ
      if ( IdxNH3 /= 0 ) then 
        DelMolFr =                                              &
          & max (                                               &
          &    DelMolFrNH4SH(                                   &
          &         z_Temp(k+1), z_Press(k+1),                  &
          &         za_MolFr(k+1,IdxNH3), za_MolFr(k+1,IdxH2S),       &
          &         Humidity                                    &
          &      ),                                             &
          &    0.0d0                                            &
          &  )
        za_MolFr(k+1,IdxNH3) = za_MolFr(k+1,IdxNH3) - DelMolFr
        za_MolFr(k+1,IdxH2S) = za_MolFr(k+1,IdxH2S) - DelMolFr
      end if
      
      !------------------------------------------------------------
      !ٸۤ׻
      !------------------------------------------------------------
      !ɽ̤Ǥʿʬ̤
      MolWtMeanDry = MolWtDry * (1.0d0 - sum(za_MolFr(k+1, 1:SpcNum)))
      MolWtMeanWet = dot_product(MolWtWet(1:SpcNum), za_MolFr(k+1, 1:SpcNum))
      z_MolWtMean(k+1) = MolWtMeanDry + MolWtMeanWet

    end do DtDz
    
  end subroutine ECCM_Dry


!!------------------------------------------------------------------------------!!!
!  subroutine ECCM_Wet( a_MolFrIni, Humidity, z_Temp, z_Press, z_MolWtMean, za_MolFr )
  subroutine ECCM_Wet( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
    !
    !== 
    !  * ǮٸΨ˱ä١ϤᡢФƻꤵ줿м٤Ȥʤ褦˶ŷʬΥ
    !  * Ǯϴ絤ΤΤɽ
    !    * ήΤˤǮϴʬΤΤɽƤ뤿
    !  * 絤ʿʬ̤ˤϼʬʬ̤
    !    * ήΤˤ, ʬʬ̤ϹθƤ뤿
    !
    
    !ۤηػ
    implicit none
    
    real(8), intent(in) :: a_MolFrIni(1:SpcNum)    !ǤΥ
    real(8), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
    real(8), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(8), intent(out):: z_Press(DimZMin:DimZMax)!
!    real(8), intent(out):: z_MolWtMean(DimZMin:DimZMax) 
    real(8)             :: z_MolWtMean(DimZMin:DimZMax) 
                                                   !ʿʬ
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum) 
                                                   !ʬΨ
    real(8)             :: MolWtMeanDry            !絤ʬ̤κѿ
    real(8)             :: MolWtMeanWet            !ᵤʬ̤κѿ
    real(8)             :: SatPress                !˰¾
    real(8)             :: VapPress                !
    real(8)             :: DelMolFr
    integer             :: k, s, j
    
    real(8)             :: TempA, PressA, a_MolFrA(SpcNum)
    real(8)             :: TempN, PressN, a_MolFrN(SpcNum)
    real(8)             :: DZ
    real(8)             :: A, B
    real(8)             :: Heat(SpcNum)
    real(8)             :: ReactHeat
    logical             :: MoistFlag(SpcNum), ReactFlag
    
    !-------------------------------------------------------------
    ! ν
    !-------------------------------------------------------------
    !ɽ̤ʬ̤
    za_MolFr(RegZMin+1, 1:SpcNum)   = a_MolFrIni(1:SpcNum) 
    
    !ɽ̤Ǥʿʬ̤
    MolWtMeanDry = MolWtDry * (1.0d0 - sum(a_MolFrIni))
    MolWtMeanWet = dot_product(MolWtWet, a_MolFrIni) 
    z_MolWtMean(RegZMin+1) = MolWtMeanDry + MolWtMeanWet
  
    !ɽ̤Ǥβ(RegZMin+1 ,  DelZ / 2 )
    z_Temp          = 1.0d-60
    z_Temp(RegZMin+1) = TempSfc - Grav * MolWtDry / CpDryMol * ( DelZ * 5.0d-1 )

    !ɽ̤Ǥΰ(RegZMin ,  DelZ / 2 )
    z_Press           = 1.0d-60
    z_Press(RegZMin+1)  = PressSfc *((TempSfc / z_Temp(RegZMin+1)) ** (- CpDryMol /  GasRUniv))

    !-----------------------------------------------------------
    ! ǮΨ dT/dz η׻. 
    !-----------------------------------------------------------    
    DtDz: do k = RegZMin+1, DimZMax-1
      TempN  = z_Temp(k)
      PressN = z_Press(k)
      a_MolFrN = za_MolFr(k,:)
      
      DZ = DelZ/100
      do j = 1, 100
        MoistFlag = .false.
        Heat = 0.0d0   
        a_MolFrA = a_MolFrN  !
        
        !Ǯ˱ä k+1 Ǥβ٤׻
        TempA = TempN - Grav * MolWtDry / CpDryMol * DZ
!        write(*,*) "TempA", TempA
        
        !ǰ
        if (TempA <= 0.0d0 ) TempA = TempN
        
        !Ϥſ尵ʿդ׻
        PressA = PressN * ((TempN / TempA) ** (- CpDryMol / GasRUniv))
        
        ! ŷ뤬뤫Ƚ
        do s = 1, CondNum      
          !˰¾
          SatPress = SvapPress( SpcWetID(IdxCC(s)), TempA )
          
          !ΥʬΨѤƸߤξ׻
          VapPress = a_MolFrN(IdxCG(s)) * PressA
          
          !˰¾ŷ̵ͭ
          if ( VapPress < SatPress ) then         
            !ŷ뤷ƤʤΤǮʤ.
            a_MolFrA(IdxCG(s)) = a_MolFrN(IdxCG(s))
            !ŷ뤷ʤΤǮʤ
            Heat(IdxCG(s)) = 0.0d0
          else
            !Ǯ. ߤι٤Ǥ
            Heat(IdxCG(s)) = LatentHeatPerMol( SpcWetID(IdxCC(s)), TempN )
            !ŷΥå
            MoistFlag(s) = .true.
          end if
        end do

        !NH4SH ʿվ
        if ( IdxNH3 /= 0 ) then      
          DelMolFr =                                            &
            & max (                                             &
            &    DelMolFrNH4SH(                                 &
            &         TempA, PressA, a_MolFrN(IdxNH3), a_MolFrN(IdxH2S),&
            &         Humidity                                  &
            &      ),                                           &
            &    0.0d0                                          &
            &  )
          ! ȿǮ
          ReactHeat = ReactHeatNH4SHPerMol * DelMolFr
          ! ȿΥå
          if (DelMolFr > 0) ReactFlag = .true. 
        end if

!        write(*,*) "MoistFlag", MoistFlag
!        write(*,*) "ReactFlag", ReactFlag
        
        if (count(MoistFlag) > 0 .or. ReactFlag) then 
          !.  k Ǥͤɾ
          A = dot_product( Heat(1:SpcNum), a_MolFrN(1:SpcNum)) / ( GasRUniv * TempN )
          B = dot_product(( Heat(1:SpcNum) ** 2.0d0), a_MolFrN(1:SpcNum)) &
            & / ( CpDryMol * GasRUniv * ( TempN ** 2.0d0 ) )
          
          !ǮٸΨ
          TempA = TempN - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B)) * DZ &
            &       + ReactHeat / (CpDryMol * DelZ)
!          write(*,*) "Moist TempA",   TempA
!          write(*,*) "Moist Heat ",   Heat
!          write(*,*) "Moist MolFr ",  a_MolFrN
!          write(*,*) "Moist DTempDZ", - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B))
          
          !ǰ
          if (TempA <= 0.0d0 ) TempA = TempN
          
          !Ϥſ尵ʿդ׻
          PressA = PressN * ((TempN / TempA) ** (- CpDryMol / GasRUniv)) 
          
          do s = 1, CondNum              
            if (MoistFlag(s)) then 
              !˰¾
              SatPress = SvapPress( SpcWetID(IdxCC(s)), TempA )
              ! ˰¥
              a_MolFrA(IdxCG(s)) = max(SatPress / PressA, 1.0d-16)
            else
              ! ΥƱ
              a_MolFrA(IdxCG(s)) = a_MolFrN(IdxCG(s)) 
            end if
          end do

          if ( ReactFlag ) then 
            DelMolFr =                                            &
              & max (                                             &
              &    DelMolFrNH4SH(                                 &
              &         TempA, PressA, a_MolFrA(IdxNH3), a_MolFrA(IdxH2S),&
              &         Humidity                                  &
              &      ),                                           &
              &    0.0d0                                          &
              &  )
            a_MolFrA(IdxNH3) = a_MolFrA(IdxNH3) - DelMolFr
            a_MolFrA(IdxH2S) = a_MolFrA(IdxH2S) - DelMolFr
          end if
        end if
        
        TempN  = TempA
        PressN = PressA
        a_MolFrN = a_MolFrA        
      end do
        
      z_Temp(k+1)     = TempA
      z_Press(k+1)    = PressA
      za_MolFr(k+1,:) = a_MolFrA(:)
      
      !ʿʬ̤
      MolWtMeanDry = MolWtDry * (1.0d0 - sum(za_MolFr(k+1, 1:SpcNum)))
      MolWtMeanWet = dot_product(MolWtWet(1:SpcNum), za_MolFr(k+1, 1:SpcNum))
      z_MolWtMean(k+1) = MolWtMeanDry + MolWtMeanWet
    end do DtDz
    
  end subroutine ECCM_Wet


!!------------------------------------------------------------------------------!!!
  subroutine ECCM_Wet2( Idx, Humidity, z_Temp, z_Press, za_MolFr)
    !
    !== 
    !  * ǮٸΨ˱ä١ϤᡢФƻꤵ줿м٤Ȥʤ褦˶ŷʬΥ
    !  * Ǯϴ絤ΤΤɽ
    !    * ήΤˤǮϴʬΤΤɽƤ뤿
    !  * 絤ʿʬ̤ˤϼʬʬ̤
    !    * ήΤˤ, ʬʬ̤ϹθƤ뤿
    !
    
    !ۤηػ
    implicit none
    
    integer             :: Idx
    real(8), intent(inout) :: z_Temp(DimZMin:DimZMax)    !ǤΥ
    real(8), intent(inout) :: z_Press(DimZMin:DimZMax) !ǤΥ
    real(8), intent(inout) :: za_MolFr(DimZMin:DimZMax, 1:SpcNum)    !ǤΥ
    real(8), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
    real(8)             :: SatPress                !˰¾
    real(8)             :: VapPress                !
    real(8)             :: DelMolFr
    integer             :: k, s, j
    
    real(8)             :: TempA, PressA, a_MolFrA(SpcNum)
    real(8)             :: TempN, PressN, a_MolFrN(SpcNum)
    real(8)             :: DZ
    real(8)             :: A, B
    real(8)             :: Heat(SpcNum)
    real(8)             :: ReactHeat
    logical             :: MoistFlag(SpcNum), ReactFlag
    

    !-----------------------------------------------------------
    ! ǮΨ dT/dz η׻. 
    !-----------------------------------------------------------    
    DtDz: do k = Idx, DimZMax-1
      TempN  = z_Temp(k)
      PressN = z_Press(k)
      a_MolFrN = za_MolFr(k,:)
      
      DZ = DelZ/100
      do j = 1, 100
        MoistFlag = .false.
        Heat = 0.0d0   
        a_MolFrA = a_MolFrN  !
        
        !Ǯ˱ä k+1 Ǥβ٤׻
        TempA = TempN - Grav * MolWtDry / CpDryMol * DZ
!        write(*,*) "TempA", TempA
        
        !ǰ
        if (TempA <= 0.0d0 ) TempA = TempN
        
        !Ϥſ尵ʿդ׻
        PressA = PressN * ((TempN / TempA) ** (- CpDryMol / GasRUniv))
        
        ! ŷ뤬뤫Ƚ
        do s = 1, CondNum      
          !˰¾
          SatPress = SvapPress( SpcWetID(IdxCC(s)), TempA )
          
          !ΥʬΨѤƸߤξ׻
          VapPress = a_MolFrN(IdxCG(s)) * PressA
          
          !˰¾ŷ̵ͭ
          if ( VapPress < SatPress ) then         
            !ŷ뤷ƤʤΤǮʤ.
            a_MolFrA(IdxCG(s)) = a_MolFrN(IdxCG(s))
            !ŷ뤷ʤΤǮʤ
            Heat(IdxCG(s)) = 0.0d0
          else
            !Ǯ. ߤι٤Ǥ
            Heat(IdxCG(s)) = LatentHeatPerMol( SpcWetID(IdxCC(s)), TempN )
            !ŷΥå
            MoistFlag(s) = .true.
          end if
        end do

        !NH4SH ʿվ
        if ( IdxNH3 /= 0 ) then      
          DelMolFr =                                            &
            & max (                                             &
            &    DelMolFrNH4SH(                                 &
            &         TempA, PressA, a_MolFrN(IdxNH3), a_MolFrN(IdxH2S),&
            &         Humidity                                  &
            &      ),                                           &
            &    0.0d0                                          &
            &  )
          ! ȿǮ
          ReactHeat = ReactHeatNH4SHPerMol * DelMolFr
          ! ȿΥå
          if (DelMolFr > 0) ReactFlag = .true. 
        end if

!        write(*,*) "MoistFlag", MoistFlag
!        write(*,*) "ReactFlag", ReactFlag
        
        if (count(MoistFlag) > 0 .or. ReactFlag) then 
          !.  k Ǥͤɾ
          A = dot_product( Heat(1:SpcNum), a_MolFrN(1:SpcNum)) / ( GasRUniv * TempN )
          B = dot_product(( Heat(1:SpcNum) ** 2.0d0), a_MolFrN(1:SpcNum)) &
            & / ( CpDryMol * GasRUniv * ( TempN ** 2.0d0 ) )
          
          !ǮٸΨ
          TempA = TempN - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B)) * DZ &
            &       + ReactHeat / (CpDryMol * DZ)
!          write(*,*) "Moist TempA",   TempA
!          write(*,*) "Moist Heat ",   Heat
!          write(*,*) "Moist MolFr ",  a_MolFrN
!          write(*,*) "Moist DTempDZ", - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B))
          
          !ǰ
          if (TempA <= 0.0d0 ) TempA = TempN
          
          !Ϥſ尵ʿդ׻
          PressA = PressN * ((TempN / TempA) ** (- CpDryMol / GasRUniv)) 
          
          do s = 1, CondNum              
            if (MoistFlag(s)) then 
              !˰¾
              SatPress = SvapPress( SpcWetID(IdxCC(s)), TempA )
              ! ˰¥
              a_MolFrA(IdxCG(s)) = max(SatPress / PressA, 1.0d-16)
            else
              ! ΥƱ
              a_MolFrA(IdxCG(s)) = a_MolFrN(IdxCG(s)) 
            end if
          end do

          if ( ReactFlag ) then 
            DelMolFr =                                            &
              & max (                                             &
              &    DelMolFrNH4SH(                                 &
              &         TempA, PressA, a_MolFrA(IdxNH3), a_MolFrA(IdxH2S),&
              &         Humidity                                  &
              &      ),                                           &
              &    0.0d0                                          &
              &  )
            a_MolFrA(IdxNH3) = a_MolFrA(IdxNH3) - DelMolFr
            a_MolFrA(IdxH2S) = a_MolFrA(IdxH2S) - DelMolFr
          end if
       end if
        
        TempN  = TempA
        PressN = PressA
        a_MolFrN = a_MolFrA        
      end do
        
      z_Temp(k+1)     = TempA
      z_Press(k+1)    = PressA
      za_MolFr(k+1,:) = a_MolFrA(:)
      
   end do DtDz
    
  end subroutine ECCM_Wet2

!!------------------------------------------------------------------------------!!!
  subroutine HUM(z_humid, kansoku_altitude, kansoku_HumZ)
    !
    !== 
    !
    !  * Yamasaki, 1983 μ٤δ¬ǡܾ 
    !    * м٤δ¬ǡNetCDFե벽Τͤɤ߹
    !    * ɤ߹֤ͤм٤δܾ
    !

    implicit none

    real(8) :: Observed_Humidity(1:100,1:88)        !NetCDF ɤ߹м٤δ¬
                                                    !ʿͤ2ǡ
    real(8),intent(out) :: kansoku_HumZ(1:88)       !ľ1ˤм٤δ¬ͤ
    real(8),intent(out) :: z_humid(DimZMin:DimZMax) !֤м
    real(8),intent(out) :: kansoku_altitude(1:89)   !¬ǡб
    integer :: k,m

    z_humid = 0.0d0
    kansoku_altitude = 0.0d0
    kansoku_HumZ = 0.0d0

    ! ¬ǡб٤Ϳ
    ! ֤κݤ˻Ѥ
    ! ʤ, Yamsaki(1983)ˤ븵ǡϥǡֳ֤ФФǤäΤ
    ! 250mֳ֤ľΤѤƤ
    do m = 1,89
     kansoku_altitude(m) = 25.0d1*(m-1)
    end do

    ! NetCDF ե뤫м٤ɤ߹
    call HistoryGet('Ob_Humidity.nc', 'Ob_Humidity', array=Observed_Humidity)

    ! м٤δ¬ͤΥե"Ob_Humidity.nc"2ǡ(x,z)Ǥ뤿
    ! 1ǡˤ
    do m=1,88
      kansoku_HumZ(m)  = Observed_Humidity(1,m)
    end do

    ! kansoku_HumZ ֤z_humid
    ! kansoku_altitude(m) < s_Z(k) < kansoku_altitude(m+1),
    ! kansoku_altitude = s_Z(k),
    ! kansoku_altitude < s_Z(k)
    ! 3ĤǾʬ
    do k = RegZMin+1,DimZMax
     do m = 1,87
      if (kansoku_altitude(m).ne.s_Z(k).and.s_Z(k).gt.kansoku_altitude(m) &
         & .and.s_Z(k).lt.kansoku_altitude(m+1)) then
        z_humid(k) = kansoku_HumZ(m)+((kansoku_HumZ(m+1) - kansoku_HumZ(m)) &
        & /(kansoku_altitude(m+1)-kansoku_altitude(m)))*(s_Z(k)-kansoku_altitude(m))

      else if (kansoku_altitude(m).eq.s_Z(k)) then
        z_humid(k) = kansoku_HumZ(m)

      else if (kansoku_altitude(m).lt.s_Z(k)) then
        z_humid(k) = z_humid(k-1)
      end if
     end do
    end do

  end subroutine HUM

!!------------------------------------------------------------------------------!!!
  subroutine ECCM_N1994( z_Temp, z_Press, za_MolFr )
    !
    !== 
    !  * Yamasaki, 1983 β٤м٤δ¬ͤǴܾ
    !    * ٤δܾ
    !      * ¬ǡNetCDFե벽Τͤɤ߹
    !        * ɤ߹֤ͤƲ٤δܾ
    !    * ٤δܾ
    !      * м٤ subroutine HUM ǺѤ
    !        * Ǥм٤ѴƼ٤δܾ 
    !    * δܾ
    !      * ʬȴʬʬ̺θſ尵ʿդ׻
    !

    implicit none

    real(8), intent(out):: z_Press(DimZMin:DimZMax)!
    real(8), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum) !
    real(8)             :: Ob_altitude(1:89)       !¬ǡб
    real(8)             :: Ob_HumZ(1:88)           !м٤δ¬(1)
    real(8)             :: z_HumZ(DimZMin:DimZMax) !м٤δܾ(%)
    real(8)        :: Observed_Temp(1:100,1:89)!NetCDF ɤ߹δ¬(2)
    real(8)        :: Ob_TempZ(1:89)           !NetCDF ɤ߹δ¬(1)
    real(8)             :: z_PressSaturated(DimZMin:DimZMax)!Tetens(1930) ˰¾
    integer             :: k, s, i, m, b

    z_HumZ = 0.0d0

    ! subroutine HUMм٤δܾ
    call HUM(z_HumZ, Ob_altitude, Ob_HumZ)

    ! ٥ǡNetCDF֤

    ! NetCDF ե뤫εδ¬ͤɤ߹
    call HistoryGet('Ob_Temp.nc', 'Ob_Temp', array=Observed_Temp)

    ! ٤δ¬ͤΥե"Ob_Temp.nc"2ǡ(x,z)ʤΤ
    ! 1ǡ(z)ˤ
    do m=1,89
      Ob_TempZ(m) = Observed_Temp(1,m)
    end do

    ! Ob_TempZ ֤Ʋ٤δܾ z_Temp 
    ! kansoku_altitude(m) < s_Z(k) < kansoku_altitude(m+1),
    ! kansoku_altitude = s_Z(k),
    ! kansoku_altitude < s_Z(k)
    ! 3ĤǾʬ

    ! 
    z_Temp = 1.0d-60      

    do k = RegZMin+1,DimZMax
     do m = 1,88

      ! s_Z  Ob_altitude Τ֤˶ޤȤ,
      ! ζ֤ Obaltitude(m), Obaltitude(m+1) 
      ! ľ Ob_TempZ ֤
      if (Ob_altitude(m).ne.s_Z(k).and.s_Z(k).gt.Ob_altitude(m) &
          & .and.s_Z(k).lt.Ob_altitude(m+1)) then
        z_Temp(k) = Ob_TempZ(m)+((Ob_TempZ(m+1)-Ob_TempZ(m)) &
        & /(Ob_altitude(m+1)-Ob_altitude(m)))*(s_Z(k)-Ob_altitude(m))

      ! s_Z(k) = Obaltitude(m) λ, Ob_TempZ(m) = z_Temp(k) Ǥ
      else if (Ob_altitude(m).eq.s_Z(k)) then
        z_Temp(k) = Ob_TempZ(m)

      ! s_Z(k) > Ob_altitude Ǥϴ¬ǡ̵Τ絤ˤ
      else if (Ob_altitude(m).lt.s_Z(k)) then
        z_Temp(k) = z_Temp(k-1)

      end if
     end do
    end do

    ! ȥ׻

    ! 
    z_Press = 1.0d-60

    ! ɽ̵Ȳ٤絤ǲؤε
    ! ſ尵μ dP/dz = - \rho * g 
    ! ñΤ, \rho = 1 kg/m^3 δ絤ꤷƤ
    z_Press(RegZMin+1) = PressSfc - (Grav * DelZ)

    ! 絤ǲؤΥ׻
    za_MolFr(RegZMin+1,1) = SvapPress( 6,z_Temp(RegZMin+1)) * &
                           &(z_HumZ(RegZMin+1)/100)/z_Press(RegZMin+1)

    ! Tetens(1930) ˰¾ȤäƤߤΤǰʲǷ׻
    do k=RegZMin+1,DimZMax
      z_PressSaturated(k) = 6.11*(10**(7.5*(z_Temp(k)-273)/(z_Temp(k)-35.7)))*100
    end do

    ! 絤ǲؤͤ򸵤, ȼ٤δܾ
    ! ϼʬȴʬʬ̺θſ尵ʿդ׻
    ! м٤ϥѴ
    ! ʲifʸDryHeightϴܾ˴礷ؤɬפ
    ! NAMELISTǱľΰʾͤꤷƤд礷ؤʤ

    ! ٤δܾη׻
    do k = RegZMin+1,DimZMax-1
     if (s_Z(k+1).lt.DryHeight) then
        za_MolFr(k+1,1) = SvapPress( 6,z_Temp(k)) * (z_HumZ(k)/100)/z_Press(k)

    ! δܾη׻
      z_Press(k+1) = &
         & z_Press(k)-(Grav*z_Press(k)*DelZ) &
         & /((GasRUniv/ &
         & (MolWtDry + za_MolFr(k,1) * (MolWtWet(1) - MolWtDry))) &
         & *z_Temp(k))

      !DryHeightΰ褬ȤϾǵ᤿򥼥ˤ
      !絤ˤſ尵μ鵤
      else if (s_Z(k+1).ge.DryHeight) then
        za_MolFr(k+1,1) = 0.0d0

        z_Press(k+1) = &
           & z_Press(k)-(Grav*z_Press(k)*DelZ) &
           & /((GasRUniv/MolWtDry)*z_Temp(k))
      end if
    end do


 end subroutine ECCM_N1994

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007(z_RH,Ztr,TR,LL)
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * Takemi(2007) ǮӾپм٤"BASE CASE"
    !      1.5km ʾμ٤׻Ƥ(ܺ٤Takemi(2007)ο2򻲾ȤΤ)
    !     * Takemi(2007)ǤϹ1.5kmʾϤؿͿƤ뤬,
    !       1.5kmʲϰκͿƤ뤿,
    !       1.5kmʲμ٤ϲ٤䵤ޤʤʤΤǸǵ
    !
    implicit none

    real(8),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity(м)
    real(8),intent(out) :: Ztr                   !ή̤ι
    integer,intent(out) :: TR                    !ή̤ι٤γʻֹ
    integer,intent(out) :: LL                    ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

    ! Ztrή̹٤ͤͿ
    ! Takemi(2007)Ǥ12km, ɬʻ礦12kmˤϾʤ,
    ! 12km,12kmľΰ֤ή̤ˤ
    do k = RegZMin+1,DimZMax

      ! s_Z  礦 12 km ʤ 12 km ή
      if (s_Z(k).eq.12000) then
        Ztr = s_Z(k)

      ! s_Z 礦12kmǤϤʤä,12kmľs_ZήZtrˤʤ
      else if (s_Z(k).gt.12000) then
        Ztr = minval( s_Z, 1, s_Z > 12000 )
      end if
    end do

    ! ή̹٤γʻ (Ztr = s_Z(TR))
    do k = RegZMin+1,DimZMax
      if (s_Z(k).ge.12000.and.s_Z(k).le.(12000 + DelZ)) then
        TR = k
      end if
    end do

    ! 1.5km⤷Ϥľγʻֹ
    do k = RegZMin+1,DimZMax
      if (s_Z(k).le.1500.and.s_Z(k).ge.(1500 - DelZ)) then
        LL = k
      end if
    end do

    ! Takemi(2007)μѤм٤
    ! Ȥꤢ1.5kmʲμ٤ϥˤƤ
    do k = RegZMin+1, DimZMax
      if (k.le.LL) then
        z_RH(k) = 0.0d0

      else if (k.le.TR.and.k.gt.LL) then
        z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25

      else if (k.gt.TR) then
        z_RH(k) = 0.25
      end if
    end do
  end subroutine HUM_Takemi2007

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007_TDRY(z_RH,Ztr,TR,LL)
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * Takemi(2007) ǮӾپм٤"DRY CASE"
    !      1.5km ʾμ٤׻Ƥ(ܺ٤Takemi(2007)ο2򻲾ȤΤ)
    !     * Takemi(2007)ǤϹ1.5kmʾϤؿͿƤ뤬,
    !       1.5kmʲϰκͿƤ뤿,
    !       1.5kmʲμ٤ϲ٤䵤ޤʤʤΤǸǵ
    !     * پȤϴΤ㤦
    !

    implicit none

    real(8),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity(м)
    real(8),intent(out) :: Ztr                   !ή̤ι
    integer,intent(out) :: TR                    !ή̤ι٤γʻֹ
    integer,intent(out) :: LL                    ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

    ! Ztrή̹٤ͤͿ
    ! Takemi(2007)Ǥ12km, ɬʻ礦12kmˤϾʤ,
    ! 12km,12kmľΰ֤ή̤ˤ
    do k = RegZMin+1,DimZMax

      ! s_Z  礦 12 km ʤ 12 km ή
      if (s_Z(k).eq.12000) then
        Ztr = s_Z(k)

      ! s_Z 礦12kmǤϤʤä,12kmľs_ZήZtrˤʤ
      else if (s_Z(k).gt.12000) then
        Ztr = minval( s_Z, 1, s_Z > 12000 )
      end if
    end do

    ! ή̹٤γʻ (Ztr = s_Z(TR))
    do k = RegZMin+1,DimZMax
      if (s_Z(k).ge.12000.and.s_Z(k).le.(12000 + DelZ)) then
        TR = k
      end if
    end do

    ! 1.5km⤷Ϥľγʻֹ
    do k = RegZMin+1,DimZMax
      if (s_Z(k).le.1500.and.s_Z(k).ge.(1500 - DelZ)) then
        LL = k
      end if
    end do

    ! Takemi(2007)μѤм٤
    ! Ȥꤢ1.5kmʲμ٤ϥˤƤ
    ! , 絤Υȥ쥤ȤθǮӤ"DRY CASE"Ǥ
    !  2.5 km, 5.0 km, 7.5 km Τɤм٤ 20 % 餹DRY1,2,3Ѱդ
    do k = RegZMin+1, DimZMax
      if (k.le.LL) then
        z_RH(k) = 0.0d0

      ! 1.5 km  (2.5 km, 5.0 km, 7.5 km) ޤǤϤΤޤѲ

!     else if (s_Z(k).lt.2500.and.k.gt.LL) then   ! DRY1
!     else if (s_Z(k).lt.5000.and.k.gt.LL) then   ! DRY2
      else if (s_Z(k).lt.7500.and.k.gt.LL) then   ! DRY3
        z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25

      ! (2.5 km, 5.0 km, 7.5 km)20 % ٤򸺾 
!     else if (s_Z(k).ge.2500) then   ! DRY1
!     else if (s_Z(k).ge.5000) then   ! DRY2
      else if (s_Z(k).ge.7500) then   ! DRY3
        z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25 - 0.20d0

      end if
    end do

    ! м٤ 25% ʲˤʤ 25% Ǹꤹ
    do k = RegZMin+1, DimZMax
      if (z_RH(k).le.(0.25).and.k.gt.LL) then
        z_RH(k) = 0.250d0
      end if
    end do

  end subroutine HUM_Takemi2007_TDRY

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007_MDRY(z_RH,Ztr,TR,LL)
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * Takemi(2007) ǮӾپм٤"DRY CASE"
    !      1.5km ʾμ٤׻Ƥ(ܺ٤Takemi(2007)ο2򻲾ȤΤ)
    !     * Takemi(2007)ǤϹ1.5kmʾϤؿͿƤ뤬,
    !       1.5kmʲϰκͿƤ뤿,
    !       1.5kmʲμ٤ϲ٤䵤ޤʤʤΤǸǵ
    !     * ǮӾȤϴΤ㤦

    implicit none

    real(8),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity(м)
    real(8),intent(out) :: Ztr                   !ή̤ι
    integer,intent(out) :: TR                    !ή̤ι٤γʻֹ
    integer,intent(out) :: LL                    ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

    ! Ztrή̹٤ͤͿ
    ! Takemi(2007)Ǥ12km, ɬʻ礦12kmˤϾʤ,
    ! 12km,12kmľΰ֤ή̤ˤ
    do k = RegZMin+1,DimZMax

      ! s_Z  礦 12 km ʤ 12 km ή
      if (s_Z(k).eq.12000) then
        Ztr = s_Z(k)

      ! s_Z 礦12kmǤϤʤä,12kmľs_ZήZtrˤʤ
      else if (s_Z(k).gt.12000) then
        Ztr = minval( s_Z, 1, s_Z > 12000 )
      end if
    end do

    ! ή̹٤γʻ (Ztr = s_Z(TR))
    do k = RegZMin+1,DimZMax
      if (s_Z(k).ge.12000.and.s_Z(k).le.(12000 + DelZ)) then
        TR = k
      end if
    end do

    ! 1.5km⤷Ϥľγʻֹ
    do k = RegZMin+1,DimZMax
      if (s_Z(k).le.1500.and.s_Z(k).ge.(1500 - DelZ)) then
        LL = k
      end if
    end do


    ! Takemi(2007)μѤм٤
    ! Ȥꤢ1.5kmޤǤμ٤ϥˤƤ
    ! 絤Υȥ쥤Ȥθپ"DRY CASE"Ǥ
    !  2.5 km м٤ 13 % ⤷ 30 % 餹 DRY1,2 Ѱդ.
    do k = RegZMin+1, DimZMax
      if (k.le.LL) then
        z_RH(k) = 0.0d0

      ! 1.5 km 2.5 km ޤǤϤΤޤѲ
      else if (s_Z(k).lt.2500.and.k.gt.LL) then
        z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25

      ! 2.5 km ʹߤ 13 % or 30 % 餹
      else if (s_Z(k).ge.2500) then
!       z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25 - 0.13d0   ! DRY1
        z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25 - 0.30d0   ! DRY2

      end if
    end do

    ! м٤ 25% ʲˤʤ 25% Ǹꤹ
    do k = RegZMin+1, DimZMax
      if (z_RH(k).le.(0.25).and.k.gt.LL) then
        z_RH(k) = 0.250d0
      end if
    end do

  end subroutine HUM_Takemi2007_MDRY

!!!------------------------------------------------------------------------------!!!
  subroutine ECCM_Takemi2007( z_Temp, z_Press, za_MolFr, z_LLhumidity )
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * ܾβ٤μ̤ͿƤ뤿, ٤Ѵɬפ
    !

    implicit none

    real(8), intent(out):: z_Press(DimZMin:DimZMax)!
    real(8), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum) !
    real(8), intent(out) :: z_LLhumidity(DimZMin:DimZMax)  ! 1.5 km ޤǤм
    !
    ! ECCM_TakemiǤΤɬפѿ
    !
    real(8) :: z_TakemiRH(DimZMin:DimZMax)         ! 1.5km ʾм
    real(8) :: z_TakemiTheta(DimZMin:DimZMax)      !ܾβ
    real(8) :: Theta_0                             ! ɽ̤β
    real(8) :: Theta_tr                            ! ή̤β
    real(8) :: TakemiZtr                           ! ή̤ι
    real(8) :: HumSfc                              ! ɽ̤м
    real(8) :: a_MolFrSfc                          ! ɽ̤Υ
!!--------------------------------------------------
    integer             :: k, s, i, m, b, T, L

    z_TakemiRH = 0.0d0
    z_TakemiTheta = 0.0d0

    ! پ
    call HUM_Takemi2007(z_TakemiRH,TakemiZtr,T,L)
!   call HUM_Takemi2007_TDRY(z_TakemiRH,TakemiZtr,T,L)
!   call HUM_Takemi2007_MDRY(z_TakemiRH,TakemiZtr,T,L)

    ! ١١

    !ɽ̤β̤300K
    Theta_0 = 300.0d0

    ! پǮӾ
    ! ή̤β̤Ƕ̤Ƥ
!   Theta_tr = 343.0d0     ! 
    Theta_tr = 358.0d0     ! Ǯ

    ! 絤ǲؤβ
    z_TakemiTheta(RegZMin+1) = Theta_0 + &
                           & (Theta_tr - Theta_0)*(s_Z(RegZMin+1) / TakemiZtr)**1.25

    z_Temp  = 1.0d-60
    z_Press = 1.0d-60
    z_LLhumidity = 0.0d0

    ! 絤ǲؤε桦ʬ̤η׻

    ! ɽ̤Υ
    ! 10g/kg18g/kgκͿƤ뤿ľ
    ! ʤǮӾQ18Τ߻
    a_MolFrSfc = 0.0180d0 * MolWtDry / MolWtWet(1)  ! Q18
!   a_MolFrSfc = 0.0160d0 * MolWtDry / MolWtWet(1)  ! Q16
!   a_MolFrSfc = 0.0140d0 * MolWtDry / MolWtWet(1)  ! Q14
!   a_MolFrSfc = 0.0120d0 * MolWtDry / MolWtWet(1)  ! Q12
!   a_MolFrSfc = 0.0100d0 * MolWtDry / MolWtWet(1)  ! Q10 

    ! ɽ̤м
    ! 椫ջ. Τɬ
    HumSfc = a_MolFrSfc * PressSfc / SvapPress(6,TempSfc)

    ! 絤ǲؤε
    z_Press(RegZMin+1) = &
           & PressSfc - (Grav * PressSfc * DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + a_MolFrSfc * (MolWtWet(1) - MolWtDry))) &
           & *TempSfc)

    ! 絤ǲؤβ.̤򸵤˷׻
    ! ɽ̵ 1000hPa Ȳꤹ
    z_Temp(RegZMin+1) = z_TakemiTheta(RegZMin+1) &
                        &* (z_Press(RegZMin+1) / 100000.0d0)**(GasRDry / CpDry)

    ! 絤ǲؤΥ
    ! ǮӾQ18Τ߻
    za_MolFr(RegZMin+1,1) = 0.0180d0 * MolWtDry / MolWtWet(1)  ! Q18
!   za_MolFr(RegZMin+1,1) = 0.0160d0 * MolWtDry / MolWtWet(1)  ! Q16
!   za_MolFr(RegZMin+1,1) = 0.0140d0 * MolWtDry / MolWtWet(1)  ! Q14
!   za_MolFr(RegZMin+1,1) = 0.0120d0 * MolWtDry / MolWtWet(1)  ! Q12
!   za_MolFr(RegZMin+1,1) = 0.0100d0 * MolWtDry / MolWtWet(1)  ! Q10
 
    ! 絤ǲؤм
    ! 椫ջ. Τɬ
    z_LLhumidity(RegZMin+1) = za_MolFr(RegZMin+1,1) &
                              &* z_Press(RegZMin+1) / SvapPress(6,z_Temp(RegZMin+1))

    ! 絤ǲؤμʪ̤Ȥ˲١ٵδܾ
    !  0 - 1.5km  1.5km - Ǽ٤Ϳۤʤ,
    ! , ή̰ʾǤϲ٤μۤʤΤ, ʲ 3ѥʬ
    ! ܾ
    !  0 - 1.5km, 1.5km - ή(Ztr), Ztrʾ 
    do k = RegZMin+1, DimZMax

    !
    ! ܾ(I)
    ! 絤ǲؤ 1.5 km ʲ(k  L-1 ʲ)δܾ
    !
     if (k.le.L-1) then

      ! 
      !  1.5km ޤǤϥ椬ǤդͤǸꤵƤ
      ! , ǮӾ 18 g/kg Τ
      za_MolFr(k+1,1) = 0.0180d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0160d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0140d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0120d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0100d0 * MolWtDry / MolWtWet(1)
 
      ! 
      z_Press(k+1) = &
           & z_Press(k)-(Grav*z_Press(k)*DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + za_MolFr(k,1) * (MolWtWet(1) - MolWtDry))) &
           & *z_Temp(k))

      ! ̤鲹٤׻
      z_TakemiTheta(k+1) = Theta_0 + (Theta_tr - Theta_0)*(s_Z(k+1) / TakemiZtr)**1.25
      z_Temp(k+1) = z_TakemiTheta(k+1) * (z_Press(k+1) / 100000.0d0)**(GasRDry / CpDry)

      ! 椫м٤׻
      z_LLhumidity(k+1) = za_MolFr(k+1,1) * z_Press(k+1) / SvapPress(6,z_Temp(k+1))

      !
      !== Takemi(2007)δܾλѾ
      !  * ؤǺꤷ³ȹ 1.5km ޤǤм٤100%Ķ٤
      !  * 100% ĶƤޤä٤μ٤, ľι٤μ٤ˤ
      !    Takemi(2007)Ʊ٤αľץե뤬
      !    * ʤ
      !  * MQ16   99.% ȤͤФ, 100% ĶʤƤۤ100%
      !    ͤФƤޤ
      !    * Takemi(2007)ǤϤΤ褦ͤ褦ˤϸʤ
      !      礦ʤΤMQ18 MQ14  100% Ķľͤδ֤äͤƤ
      !      * 0.94511507230d0Ȥ嵭
      if (z_LLhumidity(k+1).gt.1) then
        z_LLhumidity(k+1) = z_LLhumidity(k)
!     if (z_LLhumidity(k+1).gt.0.99) then      !MQ16 
!       z_LLhumidity(k+1) = 0.94511507230d0    !MQ16 
     end if

     !
     ! ܾ(II)
     !  1.5km , ή̰ʲ(L < k < T)δܾ
     !
     else if (k.le.T.and.k.gt.L) then

      ! k = L Ǥм
      !  if ʸν k  L+1 Ϥޤ z_TakemiRH(L) ֳʤΤͤͿ
      z_TakemiRH(L) = z_LLhumidity(L)

      ! δܾ
      z_Press(k) = &
           & z_Press(k-1)-(Grav*z_Press(k-1)*DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + za_MolFr(k+1,1) * (MolWtWet(1) - MolWtDry))) &
           & *z_Temp(k-1))

       ! ̤鲹٤׻
       z_TakemiTheta(k) = Theta_0 + (Theta_tr - Theta_0)*(s_Z(k) / TakemiZtr)**1.25
       z_Temp(k) = z_TakemiTheta(k) * (z_Press(k) / 100000.0d0)**(GasRDry / CpDry)

       ! 絤ʿʬ
       za_MolFr(k,1) = SvapPress( 6,z_Temp(k))* z_TakemiRH(k)/z_Press(k)
     
       !
       ! ܾ(III)
       ! ή̤ (k > T) ξ
       !
       else if (k.gt.T) then

       ! δܾ
       z_Press(k) = &
           & z_Press(k-1)-(Grav*z_Press(k-1)*DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + za_MolFr(k,1) * (MolWtWet(1) - MolWtDry))) &
           & *z_Temp(k-1))

       ! ̤鲹٤׻
       z_TakemiTheta(k) = Theta_tr * exp(Grav * (s_Z(k) - TakemiZtr) / (CpDry * z_Temp(T)))
       z_Temp(k) = z_TakemiTheta(k) * (z_Press(k) / 100000.0d0)**(GasRDry / CpDry)

       ! 絤ʿʬ
       za_MolFr(k,1) = SvapPress( 6,z_Temp(k))* z_TakemiRH(k)/z_Press(k)

     end if
    end do

 end subroutine ECCM_Takemi2007

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007ALL(z_RHall)
    !
    !== 
    ! Takemi(2007) ǤμپͿԹ, 1.5kmʲȹ1.5kmʾ
    ! м٤̡˵᤿
    ! Ԥ HUM_Takemi2007 or HUM_Takemi2007_TDRY or HUM_Takemi2007_MDRY ǵ
    ! Ԥ ECCM_Takemi2007 ǵƤ.
    ! Τ, ٤Ǥм z_RHall ǧΤˤ뤿,
    ! Υ֥롼ξԤ礷Ƥ
    ! ͤγǧŪʤ, Ūɬפʤ, ECCM_MolFrɬפʤȤ
    ! м٤ɬפʤȤ⤢, Ƥ

    implicit none

    real(8),intent(out) :: z_RHall(DimZMin:DimZMax)
    real(8) :: a_MolFrIn(1:SpcNum)
    real(8) :: Humidit
    real(8) :: z_Tem(DimZMin:DimZMax)
    real(8) :: z_Pre(DimZMin:DimZMax)
    real(8) :: z_MolMea(DimZMin:DimZMax)
    real(8) :: za_MolF(DimZMin:DimZMax)
    real(8) :: ZTR
    real(8) :: z_humidity1(DimZMin:DimZMax) !0 - 1.5 km м
    real(8) :: z_humidity2(DimZMin:DimZMax) !1.5 km ʾм
    integer :: k, T, L

    !1.5kmʲμ٤
    call ECCM_Takemi2007(z_Tem, z_Pre, za_MolF, z_humidity1)

    !1.5kmʾμ٤
    !Ĥ
    call HUM_Takemi2007(z_humidity2, ZTR, T, L)
!   call HUM_Takemi2007_TDRY(z_humidity2, ZTR, T, L)
!   call HUM_Takemi2007_MDRY(z_humidity2, ZTR, T, L)

    do k = RegZMin+1, DimZMax
      if (k.le.L) then
        z_RHall(k) = z_humidity1(k)

      else if (k.gt.L) then
        z_RHall(k) = z_humidity2(k)

      end if
    end do

  end subroutine HUM_Takemi2007ALL

!!!------------------------------------------------------------------------------!!!
  subroutine ECCM_MolFr( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
    !
    ! Ϳ줿٤Ф, ǮŪ˾徺˼¸
    ! Υץե
    !

    
    !ۤηػ
    implicit none
    
    real(8), intent(in) :: a_MolFrIni(1:SpcNum)
    real(8), intent(in) :: Humidity
    real(8), intent(in) :: z_Temp(DimZMin:DimZMax)
    real(8), intent(in) :: z_Press(DimZMin:DimZMax)
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum)
    
    real(8)             :: DelMolFr
    integer             :: k, s
    

    !-----------------------------------------------------------
    ! ν
    !-----------------------------------------------------------
    do s = 1, SpcNum
      za_MolFr(:,s) = a_MolFrIni(s) 
    end do

    !-----------------------------------------------------------
    ! ǮΨ dT/dz η׻. 
    !-----------------------------------------------------------
    do k = RegZMin, DimZMax

      za_MolFr(k,:) = za_MolFr(k-1,:)
      
      !------------------------------------------------------------
      !NH4SH ʳβؼʿվ
      !------------------------------------------------------------
      do s = 1, CondNum

        !
        !ΥƥåפǤΥĶ뤳ȤϤʤ
        za_MolFr(k,IdxCG(s)) =                                 &
          & min(                                                &
          &       za_MolFr(k-1,IdxCG(s)),                      &
          &       SvapPress( SpcWetID(IdxCC(s)), z_Temp(k) ) &
          &        * Humidity / z_Press(k)                      &
          &      )
        
      end do

      !------------------------------------------------------------
      !NH4SH ʿվ
      !------------------------------------------------------------
      if ( IdxNH3 /= 0 ) then 
        
        !Ѳ. 
        !Ȥꤢ NH4SH Ф˰ 1.0 Ȥ(ȴ...).
        DelMolFr =                                            &
          & max (                                             &
          &    DelMolFrNH4SH(                                 &
          &      z_Temp(k), z_Press(k),                       &
          &      za_MolFr(k,IdxNH3), za_MolFr(k,IdxH2S), Humidity   &
          &     ),                                            &
          &    0.0d0                                          &
          &  )
        
        za_MolFr(k,IdxNH3) = za_MolFr(k,IdxNH3) - DelMolFr 
        za_MolFr(k,IdxH2S) = za_MolFr(k,IdxH2S) - DelMolFr
      end if
      
    end do
  end subroutine ECCM_MolFr



  subroutine ECCM_DTempDZ( Temp, Press, MolFr, DTempDZ )
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in) :: Temp
    real(8), intent(in) :: Press
!    real(8), intent(inout) :: MolFr(0:SpcNum)    !ʬΨ
    real(8), intent(inout) :: MolFr(1:SpcNum)    !ʬΨ
    real(8), intent(out):: DTempDZ
    real(8)             :: MolFrOrig(1:SpcNum) 
    real(8)             :: ReactHeat
    real(8)             :: Heat(SpcNum)
    real(8)             :: DelMolFr
    real(8)             :: SatPress
    real(8)             :: VapPress
    real(8)             :: Humidity
    real(8)             :: A, B
    integer             :: s

    !
    DTempDZ      = 0.0d0
    ReactHeat    = 0.0d0
    Heat         = 0.0d0
    DelMolFr     = 0.0d0
    SatPress     = 0.0d0
    VapPress     = 0.0d0
    MolFrOrig    = MolFr

    !------------------------------------------------------------
    !NH4SH ʳβؼʿվ
    !------------------------------------------------------------
    do s = 1, CondNum      
      
      !˰¾
      SatPress = SvapPress( SpcWetID(IdxCC(s)), Temp )
      
      !Ǯ. 
      Heat(IdxCG(s)) = LatentHeatPerMol( SpcWetID(IdxCC(s)), Temp )
      
      !ΥʬΨѤƸߤξ׻
      VapPress = MolFr(IdxCG(s)) * Press

      !˰¾ŷ̵ͭ
      if ( VapPress < SatPress ) then         
        !ŷ뤷ƤʤΤǮʤ.
        Heat(IdxCG(s)) = 0.0d0                  
      else      
       !˰¾ȰϤ鸽ߤΥ׻
        MolFr(IdxCG(s)) = max(SatPress / Press, 1.0d-16)        
      end if
    end do
    
    !------------------------------------------------------------
    !NH4SH ʿվ
    !------------------------------------------------------------
    if ( IdxNH3 /= 0 ) then 
      
      Humidity = 1.0d0
      DelMolFr =                                            &
        & max (                                             &
        &    DelMolFrNH4SH(                                 &
        &         Temp, Press, MolFr(IdxNH3), MolFr(IdxH2S),&
        &         Humidity                                  &
        &      ),                                           &
        &    0.0d0                                          &
        &  )
      MolFr(IdxNH3) = MolFr(IdxNH3) - DelMolFr
      MolFr(IdxH2S) = MolFr(IdxH2S) - DelMolFr

      ReactHeat = ReactHeatNH4SHPerMol * DelMolFr
    end if
    
    !------------------------------------------------------------
    !ٸۤ׻
    !------------------------------------------------------------
    !.  Temp(i) ɾ
    A = dot_product( Heat(1:SpcNum), MolFrOrig(1:SpcNum)) &
!    A = dot_product( Heat(1:SpcNum), MolFr(1:SpcNum)) &
      & / ( GasRUniv * Temp )
    B = dot_product(( Heat(1:SpcNum) ** 2.0d0), MolFrOrig(1:SpcNum)) &
!    B = dot_product(( Heat(1:SpcNum) ** 2.0d0), MolFr(1:SpcNum)) &
      & / ( CpDryMol * GasRUniv * ( Temp ** 2.0d0 ) )

    !ǮٸΨ
    DTempDZ = - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B))  &
      &       + ReactHeat / (CpDryMol * DelZ)
   
  end subroutine ECCM_DTempDZ



  subroutine ECCM_Stab( xz_PotTemp, xz_Exner, xza_MixRt )
!    &                   xz_Stab, xz_StabTemp, xz_StabMolWt )

    use gridset,  only: DimXMin,       &!  X β
      &                 DimXMax,       &!  X ξ 
      &                 DimZMin,       &!  Z β
      &                 DimZMax,       &!  Z ξ 
      &                 SpcNum          !
    use basicset,only:  MolWtDry,      &!
      &                 MolWtWet,      &!
      &                 CpDry,         &!
      &                 Grav,          &!
      &                 xz_ExnerBasicZ,   &!
      &                 xz_PotTempBasicZ, &! 
      &                 xz_EffMolWtBasicZ, &!
      &                 xza_MixRtBasicZ
    use average, only:  xz_avr_xr
    use differentiate_center2, only: xr_dz_xz
    
    implicit none

    real(8), intent(in)  :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)
    real(8), intent(in)  :: xz_Exner(DimXMin:DimXMax,  DimZMin:DimZMax)
    real(8), intent(in)  :: xza_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
!    real(8), intent(out) :: xz_Stab(DimXMin:DimXMax,   DimZMin:DimZMax)
!    real(8), intent(out) :: xz_StabTemp(DimXMin:DimXMax, DimZMin:DimZMax)
!    real(8), intent(out) :: xz_StabMolWt(DimXMin:DimXMax, DimZMin:DimZMax)

    real(8)    :: xz_Stab(DimXMin:DimXMax,   DimZMin:DimZMax)
    real(8)    :: xz_StabTemp(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)    :: xz_StabMolWt(DimXMin:DimXMax, DimZMin:DimZMax)

    real(8)    :: xza_MolFrAll(DimXMin:DimXMax,DimZMin:DimZMax,SpcNum)
    real(8)    :: xz_TempAll(DimXMin:DimXMax,  DimZMin:DimZMax)
    real(8)    :: xz_MolWtWet(DimXMin:DimXMax, DimZMin:DimZMax)
    integer    :: i, k, s

    xz_TempAll = (xz_PotTemp + xz_PotTempBasicZ) * (xz_Exner + xz_ExnerBasicZ)
    do s = 1, SpcNum
      xza_MolFrAll(:,:,s) =                             &
        &   (xza_MixRt(:,:,s) + xza_MixRtBasicZ(:,:,s)) &
        &   * MolWtDry / MolWtWet(s) 
    end do
    
    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        xz_MolWtWet(i,k) = dot_product( MolWtWet(1:GasNum), xza_MolFrAll(i,k,1:GasNum) )
      end do
    end do
    
    xz_StabTemp =                                           &
      &         Grav / xz_TempAll                           &
      &           * (   xz_avr_xr( xr_dz_xz( xz_TempAll ) ) &
      &               + Grav * xz_EffMolWtBasicZ / CpDry ) 
    xz_StabMolWt =                                          &
      &       - Grav * xz_avr_xr( xr_dz_xz( xz_MolWtWet ) ) &
      &         / ( MolWtDry * xz_EffMolWtBasicZ )   
    xz_Stab = xz_StabTemp + xz_StabMolWt
!    xz_Stab =                                               &
!      &         Grav / xz_TempAll                           &
!      &           * ( xz_avr_xr( xr_dz_xz( xz_TempAll ) )   &
!      &               + Grav * xz_EffMolWtBasicZ / CpDry )  &
!      &       - Grav * xz_avr_xr( xr_dz_xz( xz_MolWtWet ) ) &
!      &         / ( MolWtDry * xz_EffMolWtBasicZ )   

    call StoreStabTemp( xz_StabTemp ) 
    call StoreStabMolWt( xz_StabMolWt ) 

    where (xz_Stab < 1.0d-7) 
      xz_Stab = 1.0d-7
    end where

  end subroutine ECCM_Stab
  
end module ECCM
